package com.glintt.at.dmis.ws;

import javax.swing.JFrame;

import com.glintt.at.dmis.ws.gui.TestClientGuiFactory;
import com.glintt.at.dmis.ws.gui.TestClientPanel;

/**
 * @author Ricardo Rodrigues (created based on the applet source code available on
 *         https://faturas.portaldasfinancas.gov.pt/testarLigacaoWebService.action )
 */
public final class TestClientApp {

    private TestClientApp() {
    }

    public static void main(final String[] args) {
        System.setProperty("javax.net.debug", "ssl,handshake");
        System.setProperty("com.sun.xml.ws.transport.http.client.HttpTransportPipe.dump", "true");

        final JFrame frame = new JFrame(
                "Utilitrio para testes de invocao ao XML Web Service para Entrega da DMIS");

        final TestClientPanel panel = TestClientGuiFactory.createTestClientGuiPanel();

        frame.getContentPane().add(panel);

        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.pack();
        frame.setVisible(true);
    }
}
