
package com.glintt.at.dmis.ws.client;

import java.math.BigDecimal;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.datatype.XMLGregorianCalendar;


/**
 * <p>Java class for DmisWsSubmissionRequestType complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="DmisWsSubmissionRequestType">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="TaxableEntityTaxOfficeCode">
 *           &lt;simpleType>
 *             &lt;restriction base="{http://www.w3.org/2001/XMLSchema}short">
 *               &lt;pattern value="\d{4}"/>
 *             &lt;/restriction>
 *           &lt;/simpleType>
 *         &lt;/element>
 *         &lt;element name="TaxableEntityTaxID" type="{http://servicos.portaldasfinancas.gov.pt/dmis/dmisService}PtVatNumberType"/>
 *         &lt;element name="TaxPeriod">
 *           &lt;simpleType>
 *             &lt;restriction base="{http://www.w3.org/2001/XMLSchema}gYearMonth">
 *               &lt;pattern value="\d{4}-\d{2}"/>
 *               &lt;minInclusive value="2020-01"/>
 *             &lt;/restriction>
 *           &lt;/simpleType>
 *         &lt;/element>
 *         &lt;element name="SubstitutionDeclaration" type="{http://www.w3.org/2001/XMLSchema}boolean"/>
 *         &lt;element name="TaxRepresentativeTaxID" type="{http://servicos.portaldasfinancas.gov.pt/dmis/dmisService}PtVatNumberType" minOccurs="0"/>
 *         &lt;element name="CertifiedAccountantTaxID" type="{http://servicos.portaldasfinancas.gov.pt/dmis/dmisService}PtVatNumberType" minOccurs="0"/>
 *         &lt;element name="DeclarationLinesQuantity" type="{http://servicos.portaldasfinancas.gov.pt/dmis/dmisService}NumberMax9"/>
 *         &lt;element name="DeclarationLinesBlocksQuantity" type="{http://servicos.portaldasfinancas.gov.pt/dmis/dmisService}NumberPositiveMax5"/>
 *         &lt;element name="DeclarationLinesBlock" type="{http://servicos.portaldasfinancas.gov.pt/dmis/dmisService}DeclarationLinesBlockType"/>
 *         &lt;element name="AlreadyPaidTaxAmount" type="{http://servicos.portaldasfinancas.gov.pt/dmis/dmisService}PositiveMonetaryType" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "DmisWsSubmissionRequestType", propOrder = {
    "taxableEntityTaxOfficeCode",
    "taxableEntityTaxID",
    "taxPeriod",
    "substitutionDeclaration",
    "taxRepresentativeTaxID",
    "certifiedAccountantTaxID",
    "declarationLinesQuantity",
    "declarationLinesBlocksQuantity",
    "declarationLinesBlock",
    "alreadyPaidTaxAmount"
})
public class DmisWsSubmissionRequestType {

    @XmlElement(name = "TaxableEntityTaxOfficeCode")
    protected short taxableEntityTaxOfficeCode;
    @XmlElement(name = "TaxableEntityTaxID")
    protected int taxableEntityTaxID;
    @XmlElement(name = "TaxPeriod", required = true)
    protected XMLGregorianCalendar taxPeriod;
    @XmlElement(name = "SubstitutionDeclaration")
    protected boolean substitutionDeclaration;
    @XmlElement(name = "TaxRepresentativeTaxID")
    protected Integer taxRepresentativeTaxID;
    @XmlElement(name = "CertifiedAccountantTaxID")
    protected Integer certifiedAccountantTaxID;
    @XmlElement(name = "DeclarationLinesQuantity")
    protected int declarationLinesQuantity;
    @XmlElement(name = "DeclarationLinesBlocksQuantity")
    protected int declarationLinesBlocksQuantity;
    @XmlElement(name = "DeclarationLinesBlock", required = true)
    protected DeclarationLinesBlockType declarationLinesBlock;
    @XmlElement(name = "AlreadyPaidTaxAmount")
    protected BigDecimal alreadyPaidTaxAmount;

    /**
     * Gets the value of the taxableEntityTaxOfficeCode property.
     * 
     */
    public short getTaxableEntityTaxOfficeCode() {
        return taxableEntityTaxOfficeCode;
    }

    /**
     * Sets the value of the taxableEntityTaxOfficeCode property.
     * 
     */
    public void setTaxableEntityTaxOfficeCode(short value) {
        this.taxableEntityTaxOfficeCode = value;
    }

    /**
     * Gets the value of the taxableEntityTaxID property.
     * 
     */
    public int getTaxableEntityTaxID() {
        return taxableEntityTaxID;
    }

    /**
     * Sets the value of the taxableEntityTaxID property.
     * 
     */
    public void setTaxableEntityTaxID(int value) {
        this.taxableEntityTaxID = value;
    }

    /**
     * Gets the value of the taxPeriod property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getTaxPeriod() {
        return taxPeriod;
    }

    /**
     * Sets the value of the taxPeriod property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setTaxPeriod(XMLGregorianCalendar value) {
        this.taxPeriod = value;
    }

    /**
     * Gets the value of the substitutionDeclaration property.
     * 
     */
    public boolean isSubstitutionDeclaration() {
        return substitutionDeclaration;
    }

    /**
     * Sets the value of the substitutionDeclaration property.
     * 
     */
    public void setSubstitutionDeclaration(boolean value) {
        this.substitutionDeclaration = value;
    }

    /**
     * Gets the value of the taxRepresentativeTaxID property.
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getTaxRepresentativeTaxID() {
        return taxRepresentativeTaxID;
    }

    /**
     * Sets the value of the taxRepresentativeTaxID property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setTaxRepresentativeTaxID(Integer value) {
        this.taxRepresentativeTaxID = value;
    }

    /**
     * Gets the value of the certifiedAccountantTaxID property.
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getCertifiedAccountantTaxID() {
        return certifiedAccountantTaxID;
    }

    /**
     * Sets the value of the certifiedAccountantTaxID property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setCertifiedAccountantTaxID(Integer value) {
        this.certifiedAccountantTaxID = value;
    }

    /**
     * Gets the value of the declarationLinesQuantity property.
     * 
     */
    public int getDeclarationLinesQuantity() {
        return declarationLinesQuantity;
    }

    /**
     * Sets the value of the declarationLinesQuantity property.
     * 
     */
    public void setDeclarationLinesQuantity(int value) {
        this.declarationLinesQuantity = value;
    }

    /**
     * Gets the value of the declarationLinesBlocksQuantity property.
     * 
     */
    public int getDeclarationLinesBlocksQuantity() {
        return declarationLinesBlocksQuantity;
    }

    /**
     * Sets the value of the declarationLinesBlocksQuantity property.
     * 
     */
    public void setDeclarationLinesBlocksQuantity(int value) {
        this.declarationLinesBlocksQuantity = value;
    }

    /**
     * Gets the value of the declarationLinesBlock property.
     * 
     * @return
     *     possible object is
     *     {@link DeclarationLinesBlockType }
     *     
     */
    public DeclarationLinesBlockType getDeclarationLinesBlock() {
        return declarationLinesBlock;
    }

    /**
     * Sets the value of the declarationLinesBlock property.
     * 
     * @param value
     *     allowed object is
     *     {@link DeclarationLinesBlockType }
     *     
     */
    public void setDeclarationLinesBlock(DeclarationLinesBlockType value) {
        this.declarationLinesBlock = value;
    }

    /**
     * Gets the value of the alreadyPaidTaxAmount property.
     * 
     * @return
     *     possible object is
     *     {@link BigDecimal }
     *     
     */
    public BigDecimal getAlreadyPaidTaxAmount() {
        return alreadyPaidTaxAmount;
    }

    /**
     * Sets the value of the alreadyPaidTaxAmount property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigDecimal }
     *     
     */
    public void setAlreadyPaidTaxAmount(BigDecimal value) {
        this.alreadyPaidTaxAmount = value;
    }

}
