package com.glintt.at.dmis.ws.core;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Set;
import java.util.logging.Logger;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;

import org.w3c.dom.Document;

/**
 * @author Ricardo Rodrigues (created based on the applet source code available on
 *         https://faturas.portaldasfinancas.gov.pt/testarLigacaoWebService.action )
 */
public class SoapBodyHandler implements SOAPHandler<SOAPMessageContext> {

    private final Logger logger;
    private final Document xmlBody;

    public SoapBodyHandler(final Logger logger, final Document xmlBody) {
        this.logger = logger;
        this.xmlBody = xmlBody;
    }

    public Set<QName> getHeaders() {
        return null;
    }

    public boolean handleMessage(final SOAPMessageContext messageContext) {
        final boolean isRequest = (Boolean) messageContext.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);
        if (isRequest) {
            try {
                final SOAPMessage soapMsg = messageContext.getMessage();
                final SOAPEnvelope soapEnv = soapMsg.getSOAPPart().getEnvelope();
                final SOAPBody soapBody = soapEnv.getBody();
                soapBody.removeContents();
                soapBody.addDocument(this.xmlBody);

            } catch (final Exception ex) {
                final StringWriter sw = new StringWriter();
                ex.printStackTrace(new PrintWriter(sw));
                final String stacktrace = sw.toString();
                this.logger.severe("Could not intercept and add Soap Body\n\n" + stacktrace);
            }
        }

        return true;
    }

    public boolean handleFault(final SOAPMessageContext smc) {
        return true;
    }

    public void close(final MessageContext messageContext) {
    }
}
