package com.glintt.at.dmis.ws.gui;

import java.util.logging.Handler;
import java.util.logging.LogRecord;

import javax.swing.JTextArea;
import javax.swing.SwingUtilities;

/**
 * @author Ricardo Rodrigues (created based on the applet source code available on
 *         https://faturas.portaldasfinancas.gov.pt/testarLigacaoWebService.action )
 */
public final class JTextAreaLoggerHandler extends Handler {

    private final JTextArea requestTextArea;
    private final JTextArea responseTextArea;

    public JTextAreaLoggerHandler(final JTextArea requestTextArea, final JTextArea responseTextArea) {
        this.requestTextArea = requestTextArea;
        this.responseTextArea = responseTextArea;
    }

    @Override
    public void publish(final LogRecord record) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                if (record.getMessage().startsWith("REQ")) {
                    JTextAreaLoggerHandler.this.requestTextArea
                            .setText(JTextAreaLoggerHandler.this.requestTextArea.getText() + "\n"
                                    + record.getMessage().substring(3));
                } else {
                    JTextAreaLoggerHandler.this.responseTextArea
                            .setText(JTextAreaLoggerHandler.this.responseTextArea.getText() + "\n"
                                    + record.getMessage());
                }
            }
        });
    }

    @Override
    public void flush() {
    }

    @Override
    public void close() {
    }
}
