package com.glintt.at.dmis.ws.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.MatteBorder;

import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

/**
 * @author Ricardo Rodrigues (created based on the applet source code available on
 *         https://faturas.portaldasfinancas.gov.pt/testarLigacaoWebService.action )
 */
public class TestClientPanel extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    public TestClientPanel() {
        this.initComponents();
    }

    public JTextField getUserTf() {
        return this.userTf;
    }

    public JComboBox getEndpointCb() {
        return this.endpointCb;
    }

    public JButton getTestBt() {
        return this.testBt;
    }

    public JPasswordField getPasswordTf() {
        return this.passwordTf;
    }

    public JEditorPane getSoapBodyEditorPane() {
        return this.soapBodyEditorPane;
    }

    public JTextArea getRequestLogTextArea() {
        return this.requestLogTextArea;
    }

    public JTextArea getResponseLogTextArea() {
        return this.responseLogTextArea;
    }

    private void gerarRequestActionPerformed(final ActionEvent event) {

        final String[] values = { TestClientPanel.DMIS_SUBMISSION };

        final Object selected = JOptionPane.showInputDialog(null, "Selecione a Operao a invocar",
                "Operao", JOptionPane.DEFAULT_OPTION, null, values, "0");
        if (selected != null) {// null if the user cancels.
            this.getRequestLogTextArea().setText("");
            this.getResponseLogTextArea().setText("");

            final String selectedString = selected.toString();
            final String requesterNif = this.userTf.getText().contains("/")
                    ? this.userTf.getText().substring(0, this.userTf.getText().indexOf("/"))
                    : this.userTf.getText();

            if (selectedString.equals(TestClientPanel.DMIS_SUBMISSION)) {
                this.getSoapBodyEditorPane().setText(
                        TestClientPanel.DMIS_SUBMISSION_XML.replace("DEFAULT_NIFUSER", requesterNif));
            }
        }
    }

    private void initComponents() {
        // JFormDesigner - Component initialization - DO NOT MODIFY //GEN-BEGIN:initComponents
        this.mainPanel = new JPanel();
        this.userLb = new JLabel();
        this.userTf = new JTextField();
        this.endPointLb = new JLabel();
        this.endpointCb = new JComboBox();
        this.testBt = new JButton();
        this.passwordLb = new JLabel();
        this.passwordTf = new JPasswordField();
        this.gerarRequest = new JButton();
        this.soapBodyLabel = new JLabel();
        this.soapBodyScrollPane = new JScrollPane();
        this.soapBodyEditorPane = new JEditorPane();
        this.logsSplitPane = new JSplitPane();
        this.requestLogPanel = new JPanel();
        this.requestLogLabel = new JLabel();
        this.requestAreaScrollPane = new JScrollPane();
        this.requestLogTextArea = new JTextArea();
        this.responseLogPanel = new JPanel();
        this.responseLogLabel = new JLabel();
        this.responseAreaScrollPane = new JScrollPane();
        this.responseLogTextArea = new JTextArea();
        final CellConstraints cc = new CellConstraints();

        // ======== this ========
        this.setBackground(Color.white);
        this.setBorder(null);
        this.setName("this"); //$NON-NLS-1$

        this.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(final java.beans.PropertyChangeEvent e) {
                if ("border".equals(e.getPropertyName())) {
                    throw new RuntimeException();
                }
            }
        });

        // ======== mainPanel ========
        {
            this.mainPanel.setBackground(Color.white);
            this.mainPanel.setName("mainPanel"); //$NON-NLS-1$

            // ---- userLb ----
            this.userLb.setText("NIF/User:"); //$NON-NLS-1$
            this.userLb.setName("userLb"); //$NON-NLS-1$

            // ---- userTf ----
            this.userTf.setBackground(new Color(204, 204, 255));
            this.userTf.setName("userTf"); //$NON-NLS-1$

            // ---- endPointLb ----
            this.endPointLb.setText("Endere\u00e7o:"); //$NON-NLS-1$
            this.endPointLb.setName("endPointLb"); //$NON-NLS-1$

            // ---- endpointCb ----
            this.endpointCb.setName("endpointCb"); //$NON-NLS-1$

            // ---- testBt ----
            this.testBt.setText("Testar"); //$NON-NLS-1$
            this.testBt.setBackground(new Color(102, 153, 255));
            this.testBt.setForeground(Color.white);
            this.testBt.setOpaque(true);
            this.testBt.setIcon(null);
            this.testBt.setBorder(new MatteBorder(1, 1, 1, 1, Color.black));
            this.testBt.setFont(new Font("Dialog", Font.BOLD, 14)); //$NON-NLS-1$
            this.testBt.setName("testBt"); //$NON-NLS-1$

            // ---- passwordLb ----
            this.passwordLb.setText("Password:"); //$NON-NLS-1$
            this.passwordLb.setName("passwordLb"); //$NON-NLS-1$

            // ---- passwordTf ----
            this.passwordTf.setBackground(new Color(204, 204, 255));
            this.passwordTf.setName("passwordTf"); //$NON-NLS-1$

            // ---- gerarRequest ----
            this.gerarRequest.setText("Gerar Exemplo de Request Body"); //$NON-NLS-1$
            this.gerarRequest.setName("gerarRequest"); //$NON-NLS-1$
            this.gerarRequest.addActionListener(new ActionListener() {
                public void actionPerformed(final ActionEvent e) {
                    TestClientPanel.this.gerarRequestActionPerformed(e);
                }
            });

            final PanelBuilder mainPanelBuilder = new PanelBuilder(new FormLayout(
                    "default, $lcgap, 60dlu, 2*($lcgap, default), $lcgap, default:grow, $lcgap, default, $lcgap, 50dlu", //$NON-NLS-1$
                    "default, $lgap, default"), this.mainPanel); //$NON-NLS-1$

            mainPanelBuilder.add(this.userLb, cc.xy(1, 1));
            mainPanelBuilder.add(this.userTf, cc.xy(3, 1));
            mainPanelBuilder.add(this.endPointLb, cc.xy(7, 1));
            mainPanelBuilder.add(this.endpointCb, cc.xy(9, 1));
            mainPanelBuilder.add(this.testBt, cc.xywh(13, 1, 1, 3));
            mainPanelBuilder.add(this.passwordLb, cc.xy(1, 3));
            mainPanelBuilder.add(this.passwordTf, cc.xy(3, 3));
            mainPanelBuilder.add(this.gerarRequest, cc.xy(9, 3));
        }

        // ---- soapBodyLabel ----
        this.soapBodyLabel.setText("Request Body:"); //$NON-NLS-1$
        this.soapBodyLabel.setName("soapBodyLabel"); //$NON-NLS-1$

        // ======== soapBodyScrollPane ========
        {
            this.soapBodyScrollPane.setName("soapBodyScrollPane"); //$NON-NLS-1$

            // ---- soapBodyEditorPane ----
            this.soapBodyEditorPane.setName("soapBodyEditorPane"); //$NON-NLS-1$
            this.soapBodyScrollPane.setViewportView(this.soapBodyEditorPane);
        }

        // ======== logsSplitPane ========
        {
            this.logsSplitPane.setDividerLocation(400);
            this.logsSplitPane.setDoubleBuffered(true);
            this.logsSplitPane.setResizeWeight(0.5);
            this.logsSplitPane.setName("logsSplitPane"); //$NON-NLS-1$

            // ======== requestLogPanel ========
            {
                this.requestLogPanel.setName("requestLogPanel"); //$NON-NLS-1$

                // ---- requestLogLabel ----
                this.requestLogLabel.setText("Request Log"); //$NON-NLS-1$
                this.requestLogLabel.setName("requestLogLabel"); //$NON-NLS-1$

                // ======== requestAreaScrollPane ========
                {
                    this.requestAreaScrollPane.setName("requestAreaScrollPane"); //$NON-NLS-1$

                    // ---- requestLogTextArea ----
                    this.requestLogTextArea.setEditable(false);
                    this.requestLogTextArea.setName("requestLogTextArea"); //$NON-NLS-1$
                    this.requestAreaScrollPane.setViewportView(this.requestLogTextArea);
                }

                final PanelBuilder requestLogPanelBuilder = new PanelBuilder(
                        new FormLayout("default:grow", //$NON-NLS-1$
                                "default, $lgap, default:grow"), //$NON-NLS-1$
                        this.requestLogPanel);

                requestLogPanelBuilder.add(this.requestLogLabel, cc.xy(1, 1));
                requestLogPanelBuilder.add(this.requestAreaScrollPane, cc.xywh(1, 2, 1, 2));
            }
            this.logsSplitPane.setLeftComponent(this.requestLogPanel);

            // ======== responseLogPanel ========
            {
                this.responseLogPanel.setName("responseLogPanel"); //$NON-NLS-1$

                // ---- responseLogLabel ----
                this.responseLogLabel.setText("Response Log"); //$NON-NLS-1$
                this.responseLogLabel.setName("responseLogLabel"); //$NON-NLS-1$

                // ======== responseAreaScrollPane ========
                {
                    this.responseAreaScrollPane.setName("responseAreaScrollPane"); //$NON-NLS-1$

                    // ---- responseLogTextArea ----
                    this.responseLogTextArea.setEditable(false);
                    this.responseLogTextArea.setName("responseLogTextArea"); //$NON-NLS-1$
                    this.responseAreaScrollPane.setViewportView(this.responseLogTextArea);
                }

                final PanelBuilder responseLogPanelBuilder = new PanelBuilder(
                        new FormLayout("default:grow", //$NON-NLS-1$
                                "default, $lgap, default:grow"), //$NON-NLS-1$
                        this.responseLogPanel);

                responseLogPanelBuilder.add(this.responseLogLabel, cc.xy(1, 1));
                responseLogPanelBuilder.add(this.responseAreaScrollPane, cc.xywh(1, 2, 1, 2));
            }
            this.logsSplitPane.setRightComponent(this.responseLogPanel);
        }

        final PanelBuilder builder = new PanelBuilder(new FormLayout(
                "default, $lcgap, [400dlu,default]:grow, $lcgap, default", //$NON-NLS-1$
                "5*(default, $lgap), [100dlu,default]:grow, $lgap, [50dlu,default]:grow, 2*($lgap, default)"), //$NON-NLS-1$
                this);

        builder.add(this.mainPanel, cc.xy(3, 5));
        builder.add(this.soapBodyLabel, cc.xy(3, 9));
        builder.add(this.soapBodyScrollPane, cc.xywh(3, 11, 1, 2));
        builder.add(this.logsSplitPane, cc.xywh(3, 13, 1, 2));
        // JFormDesigner - End of component initialization //GEN-END:initComponents
    }

    // JFormDesigner - Variables declaration - DO NOT MODIFY //GEN-BEGIN:variables
    private JPanel mainPanel;
    private JLabel userLb;
    private JTextField userTf;
    private JLabel endPointLb;
    private JComboBox endpointCb;
    private JButton testBt;
    private JLabel passwordLb;
    private JPasswordField passwordTf;
    private JButton gerarRequest;
    private JLabel soapBodyLabel;
    private JScrollPane soapBodyScrollPane;
    private JEditorPane soapBodyEditorPane;
    private JSplitPane logsSplitPane;
    private JPanel requestLogPanel;
    private JLabel requestLogLabel;
    private JScrollPane requestAreaScrollPane;
    private JTextArea requestLogTextArea;
    private JPanel responseLogPanel;
    private JLabel responseLogLabel;
    private JScrollPane responseAreaScrollPane;
    private JTextArea responseLogTextArea;
    // JFormDesigner - End of variables declaration //GEN-END:variables

    private static final String DMIS_SUBMISSION = "Submisso de Declarao";

    private static final String DMIS_SUBMISSION_XML = "<dmis:DmisWsSubmissionRequest xmlns:dmis=\"http://servicos.portaldasfinancas.gov.pt/dmis/dmisService\">\n  <dmis:TaxableEntityTaxOfficeCode>3492</dmis:TaxableEntityTaxOfficeCode>\n   <dmis:TaxableEntityTaxID>DEFAULT_NIFUSER</dmis:TaxableEntityTaxID>\n    <dmis:TaxPeriod>2020-01</dmis:TaxPeriod>\n  <dmis:SubstitutionDeclaration>false</dmis:SubstitutionDeclaration>\n    <dmis:DeclarationLinesQuantity>1</dmis:DeclarationLinesQuantity>\n  <dmis:DeclarationLinesBlocksQuantity>1</dmis:DeclarationLinesBlocksQuantity>\n  <dmis:DeclarationLinesBlock>\n      <dmis:BlockId>1</dmis:BlockId>\n        <dmis:DeclarationLinesList>\n           <dmis:DeclarationLine>\n                <dmis:LineId>1</dmis:LineId>\n              <dmis:TaxChargeHolder>\n                    <dmis:ForeignTaxID>\n                       <dmis:CountryCode>586</dmis:CountryCode>\n                      <dmis:TaxID>123456789012</dmis:TaxID>\n                 </dmis:ForeignTaxID>\n              </dmis:TaxChargeHolder>\n               <dmis:TaxCode>17.3.1</dmis:TaxCode>\n               <dmis:TerritorialConstituencyCode>C</dmis:TerritorialConstituencyCode>\n                <dmis:TerritorialityCode>2</dmis:TerritorialityCode>\n              <dmis:OperationTypeCode>14</dmis:OperationTypeCode>\n               <dmis:OperationPerformedByRepresentative>true</dmis:OperationPerformedByRepresentative>\n               <dmis:TaxBase>\n                    <dmis:TaxBaseAmount>10</dmis:TaxBaseAmount>\n               </dmis:TaxBase>\n           </dmis:DeclarationLine>\n       </dmis:DeclarationLinesList>\n  </dmis:DeclarationLinesBlock>\n</dmis:DmisWsSubmissionRequest>\n";

}